
      const require = await (async () => {
        const { createRequire } = await import("node:module");
        return createRequire(import.meta.url);
      })();
    
import {
  require_out
} from "./chunk-AVWFCGVE.js";
import {
  BLOB_DIR,
  STATIC_DIR
} from "./chunk-FSAVFRLT.js";
import {
  __toESM
} from "./chunk-RSKIKBZH.js";

// src/build/content/static.ts
var import_fast_glob = __toESM(require_out(), 1);
import { Buffer } from "node:buffer";
import { existsSync } from "node:fs";
import { cp, mkdir, rename, rm } from "node:fs/promises";
import { join, resolve } from "node:path";
var copyStaticContent = async ({
  constants: { PUBLISH_DIR },
  utils: {
    build: { failBuild }
  }
}) => {
  const srcDir = resolve(PUBLISH_DIR, "server/pages");
  const destDir = resolve(BLOB_DIR);
  const paths = await (0, import_fast_glob.default)("**/*.+(html|json)", {
    cwd: srcDir,
    extglob: true
  });
  try {
    await Promise.all(
      paths.filter((path) => !paths.includes(`${path.slice(0, -5)}.json`)).map(async (path) => {
        const key = Buffer.from(path).toString("base64");
        await cp(join(srcDir, path), join(destDir, key), { recursive: true });
      })
    );
  } catch (error) {
    failBuild("Failed assembling static pages for upload", error instanceof Error ? { error } : {});
  }
};
var copyStaticAssets = async ({
  constants: { PUBLISH_DIR },
  utils: {
    build: { failBuild }
  }
}) => {
  try {
    await rm(resolve(STATIC_DIR), { recursive: true, force: true });
    if (existsSync(resolve("public"))) {
      await cp(resolve("public"), resolve(STATIC_DIR), { recursive: true });
    }
    if (existsSync(resolve(PUBLISH_DIR, "static"))) {
      await cp(resolve(PUBLISH_DIR, "static"), resolve(STATIC_DIR, "_next/static"), {
        recursive: true
      });
    }
  } catch (error) {
    failBuild("Failed copying static assets", error instanceof Error ? { error } : {});
  }
};
var publishStaticDir = async ({
  constants: { PUBLISH_DIR },
  utils: {
    build: { failBuild }
  }
}) => {
  try {
    await mkdir(resolve(".netlify/.next"), { recursive: true });
    await rename(resolve(PUBLISH_DIR), resolve(".netlify/.next"));
    await rename(resolve(STATIC_DIR), resolve(PUBLISH_DIR));
  } catch (error) {
    failBuild("Failed publishing static content", error instanceof Error ? { error } : {});
  }
};
var unpublishStaticDir = async ({
  constants: { PUBLISH_DIR }
}) => {
  try {
    if (existsSync(resolve(".netlify/.next"))) {
      await rename(resolve(PUBLISH_DIR), resolve(STATIC_DIR));
      await rename(resolve(".netlify/.next"), resolve(PUBLISH_DIR));
    }
  } catch (error) {
  }
};

export {
  copyStaticContent,
  copyStaticAssets,
  publishStaticDir,
  unpublishStaticDir
};
