
      const require = await (async () => {
        const { createRequire } = await import("node:module");
        return createRequire(import.meta.url);
      })();
    
import {
  SERVER_HANDLER_NAME
} from "./chunk-FSAVFRLT.js";

// src/build/config.ts
import { existsSync } from "node:fs";
import { readFile } from "node:fs/promises";
import { resolve } from "node:path";
var getPrerenderManifest = async ({
  PUBLISH_DIR
}) => {
  return JSON.parse(await readFile(resolve(PUBLISH_DIR, "prerender-manifest.json"), "utf-8"));
};
var getMiddlewareManifest = async ({
  PUBLISH_DIR
}) => {
  return JSON.parse(
    await readFile(resolve(PUBLISH_DIR, "server/middleware-manifest.json"), "utf-8")
  );
};
var setPreBuildConfig = () => {
  process.env.NEXT_PRIVATE_STANDALONE = "true";
};
var setPostBuildConfig = ({
  netlifyConfig
}) => {
  netlifyConfig.redirects ||= [];
  netlifyConfig.redirects.push({
    from: "/*",
    to: `/.netlify/functions/${SERVER_HANDLER_NAME}`,
    status: 200
  });
};
var verifyBuildConfig = ({
  constants: { PUBLISH_DIR },
  utils: {
    build: { failBuild }
  }
}) => {
  if (!existsSync(resolve(PUBLISH_DIR))) {
    failBuild("Publish directory not found, please check your netlify.toml");
  }
};

export {
  getPrerenderManifest,
  getMiddlewareManifest,
  setPreBuildConfig,
  setPostBuildConfig,
  verifyBuildConfig
};
