
      const require = await (async () => {
        const { createRequire } = await import("node:module");
        return createRequire(import.meta.url);
      })();
    

// src/build/constants.ts
import { readFileSync } from "node:fs";
import { join } from "node:path";
import { fileURLToPath } from "node:url";
var MODULE_DIR = fileURLToPath(new URL(".", import.meta.url));
var PLUGIN_DIR = join(MODULE_DIR, "../..");
var pkg = JSON.parse(readFileSync(join(PLUGIN_DIR, "package.json"), "utf-8"));
var PLUGIN_NAME = pkg.name;
var PLUGIN_VERSION = pkg.version;
var STATIC_DIR = ".netlify/static";
var BLOB_DIR = ".netlify/blobs/deploy";
var SERVER_FUNCTIONS_DIR = ".netlify/functions-internal";
var SERVER_HANDLER_NAME = "___netlify-server-handler";
var SERVER_HANDLER_DIR = join(SERVER_FUNCTIONS_DIR, SERVER_HANDLER_NAME);
var EDGE_FUNCTIONS_DIR = ".netlify/edge-functions";
var EDGE_HANDLER_NAME = "___netlify-edge-handler";
var EDGE_HANDLER_DIR = join(EDGE_FUNCTIONS_DIR, EDGE_HANDLER_NAME);

export {
  MODULE_DIR,
  PLUGIN_DIR,
  PLUGIN_NAME,
  PLUGIN_VERSION,
  STATIC_DIR,
  BLOB_DIR,
  SERVER_FUNCTIONS_DIR,
  SERVER_HANDLER_NAME,
  SERVER_HANDLER_DIR,
  EDGE_FUNCTIONS_DIR,
  EDGE_HANDLER_NAME,
  EDGE_HANDLER_DIR
};
