
      const require = await (async () => {
        const { createRequire } = await import("node:module");
        return createRequire(import.meta.url);
      })();
    
import {
  copyFetchContent,
  copyPrerenderedContent
} from "./esm-chunks/chunk-Q2JXGCEL.js";
import {
  copyStaticAssets,
  copyStaticContent,
  publishStaticDir,
  unpublishStaticDir
} from "./esm-chunks/chunk-7626G5YN.js";
import {
  createEdgeHandlers
} from "./esm-chunks/chunk-GEJMN5BZ.js";
import {
  createServerHandler
} from "./esm-chunks/chunk-76KPJ2XG.js";
import "./esm-chunks/chunk-MZGNHYE3.js";
import "./esm-chunks/chunk-AVWFCGVE.js";
import {
  restoreBuildCache,
  saveBuildCache
} from "./esm-chunks/chunk-S6FX5USF.js";
import {
  setPostBuildConfig,
  setPreBuildConfig,
  verifyBuildConfig
} from "./esm-chunks/chunk-FQII764Q.js";
import "./esm-chunks/chunk-FSAVFRLT.js";
import "./esm-chunks/chunk-RSKIKBZH.js";

// src/index.ts
var onPreBuild = async ({ constants, utils }) => {
  setPreBuildConfig();
  await restoreBuildCache({ constants, utils });
};
var onBuild = async ({ constants, utils }) => {
  verifyBuildConfig({ constants, utils });
  await saveBuildCache({ constants, utils });
  await Promise.all([
    copyStaticAssets({ constants, utils }),
    copyStaticContent({ constants, utils }),
    copyPrerenderedContent({ constants, utils }),
    copyFetchContent({ constants, utils }),
    createServerHandler({ constants }),
    createEdgeHandlers({ constants })
  ]);
};
var onPostBuild = async ({ constants, utils, netlifyConfig }) => {
  setPostBuildConfig({ netlifyConfig });
  await publishStaticDir({ constants, utils });
};
var onEnd = async ({ constants }) => {
  await unpublishStaticDir({ constants });
};
export {
  onBuild,
  onEnd,
  onPostBuild,
  onPreBuild
};
